<?php
/**
 * +----------------------------------------------------------------------
 * 接口类
 * +----------------------------------------------------------------------
 * 官网：https://www.sw-x.cn
 * +----------------------------------------------------------------------
 * 作者：小黄牛 <1731223728@qq.com>
 * +----------------------------------------------------------------------
 * 开源协议：http://www.apache.org/licenses/LICENSE-2.0
 * +----------------------------------------------------------------------
*/

namespace BaiduPNS;
use BaiduPNS\config\Config;
use BaiduPNS\config\Phone;
use BaiduPNS\Utils;

class Api {
    /**
     * 配置实例
    */
    private $config;
    /**
     * 发包实例
    */
    private $utils;
    /**
     * 接口返回值
    */
    private $curlReturn;
    
    /**
     * 初始化
    */
    public function __construct() {
        $this->config = new Config();
        $this->utils = new Utils();
    }

    /**
     * 获取接口返回值
     * @todo 无
     * @author 小黄牛
     * @version v2.5.0 + 2021.07.20
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public function getCurl() {
        return $this->curlReturn;
    }

    /**
     * AXB绑定
     * @todo 无
     * @author 小黄牛
     * @version v2.5.0 + 2021.07.20
     * @deprecated 暂不启用
     * @global 无
     * @param string 参数参考百度智能云隐私号接口文档
     * @return int 中间号
    */
    public function binding($telA, $telB, $expiration=3600, $record=1, $customer="") {
        $url = "cloud/api/v".$this->config->getVersion()."/axb/binding";
        $obj = new Phone();
        $arr = $obj->get();
        $telX = $arr['phone'];
        $areaCode = $arr['code'];
        $body = [
            "telA" => $telA,
            "telB" => $telB,
            "telX" => $telX,
            "areaCode" => $areaCode,
            "record" => $record,
            "expiration" => $expiration,
            "customer" => $customer
        ];
        //返回数据集成在Utils中
        $arr = $this->utils->curl($url, $body);
        $this->curlReturn = $arr;
        if ($arr['code'] == 0 || $arr['code'] == 10003) {
            return $telX;
        }
        return false;
    }
}