<?php
/**
 * +----------------------------------------------------------------------
 * 发包
 * +----------------------------------------------------------------------
 * 官网：https://www.sw-x.cn
 * +----------------------------------------------------------------------
 * 作者：小黄牛 <1731223728@qq.com>
 * +----------------------------------------------------------------------
 * 开源协议：http://www.apache.org/licenses/LICENSE-2.0
 * +----------------------------------------------------------------------
*/
namespace BaiduPNS;
use BaiduPNS\Signer;
use BaiduPNS\SignerException;
use BaiduPNS\config\Config;

class Utils {
    /**
     * 发送请求
     * @todo 无
     * @author 小黄牛
     * @version v2.5.0 + 2021.07.20
     * @deprecated 暂不启用
     * @global 无
     * @param string $url 请求地址
     * @param mixed $body 请求内容
     * @param mixed $method 请求方式
     * @return array
    */
    public function curl($url, $body, $method='POST') {
        $method = strtoupper($method);
        $config = new Config();
        $auth = $this->gen_auth($url, $method, $config);
        $url = $config->getBaseUrl().$url;
        
        $files = json_encode($body, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
        $headers = array(
            'Host: '.$config->getHost(),
            'Content-Type: application/json; charset=utf-8',
            'x-bce-date: '.$config->getTimestamp(),
            'Authorization: '. $auth,
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $files);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        $response = curl_exec($ch);
        // 请求头
        $request = curl_getinfo($ch, CURLINFO_HEADER_OUT);
        // 状态码
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        return json_decode($response, true);
    }

    /**
     * 获取签名
     * @todo 无
     * @author 小黄牛
     * @version v2.5.0 + 2021.07.20
     * @deprecated 暂不启用
     * @global 无
     * @param string $uri 不包含基础URL的接口URL
     * @param string $method 请求方式
     * @param Config $config 配置实例
     * @return strign 签名结果
    */
    private function gen_auth($uri = "", $method, $config) {
        $headers = array();
        $headers['host'] = $config->getHost();
        $signer = new Signer($config->getAk(), $config->getSk());
        $signer->setMethod($method);
        $signer->setUri($uri);
        $signer->setVersion($config->getVersion());
        $signer->setSignHeaders($headers);
        try {
            $signature = $signer->genAuthorization();
            return $signature;
        } catch (SignerException $e) {
            echo $e->getMessage();
            return false;
        }
    }

}
